# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class AttributeTypeUpdate(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'entity_type': 'str',
        '_global': 'str',
        'new_attribute_type': 'AttributeTypeUpdateNewAttributeType',
        'old_attribute_type_name': 'str'
    }

    attribute_map = {
        'entity_type': 'entity_type',
        '_global': 'global',
        'new_attribute_type': 'new_attribute_type',
        'old_attribute_type_name': 'old_attribute_type_name'
    }

    def __init__(self, entity_type=None, _global=None, new_attribute_type=None, old_attribute_type_name=None, local_vars_configuration=None):  # noqa: E501
        """AttributeTypeUpdate - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._entity_type = None
        self.__global = None
        self._new_attribute_type = None
        self._old_attribute_type_name = None
        self.discriminator = None

        if entity_type is not None:
            self.entity_type = entity_type
        if _global is not None:
            self._global = _global
        if new_attribute_type is not None:
            self.new_attribute_type = new_attribute_type
        if old_attribute_type_name is not None:
            self.old_attribute_type_name = old_attribute_type_name

    @property
    def entity_type(self):
        """
        The entity type containing the attribute to rename.

        :return: The entity_type of this AttributeTypeUpdate. 
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        """
        The entity type containing the attribute to rename.

        :param entity_type: The entity_type of this AttributeTypeUpdate.
        :type: str
        """

        self._entity_type = entity_type

    @property
    def _global(self):
        """
        If 'true', applies dtype mutation to all attributes with the same name.

        :return: The _global of this AttributeTypeUpdate. 
        :rtype: str
        """
        return self.__global

    @_global.setter
    def _global(self, _global):
        """
        If 'true', applies dtype mutation to all attributes with the same name.

        :param _global: The _global of this AttributeTypeUpdate.
        :type: str
        """

        self.__global = _global

    @property
    def new_attribute_type(self):
        """

        :return: The new_attribute_type of this AttributeTypeUpdate. 
        :rtype: AttributeTypeUpdateNewAttributeType
        """
        return self._new_attribute_type

    @new_attribute_type.setter
    def new_attribute_type(self, new_attribute_type):
        """

        :param new_attribute_type: The new_attribute_type of this AttributeTypeUpdate.
        :type: AttributeTypeUpdateNewAttributeType
        """

        self._new_attribute_type = new_attribute_type

    @property
    def old_attribute_type_name(self):
        """
        The attribute to rename.

        :return: The old_attribute_type_name of this AttributeTypeUpdate. 
        :rtype: str
        """
        return self._old_attribute_type_name

    @old_attribute_type_name.setter
    def old_attribute_type_name(self, old_attribute_type_name):
        """
        The attribute to rename.

        :param old_attribute_type_name: The old_attribute_type_name of this AttributeTypeUpdate.
        :type: str
        """

        self._old_attribute_type_name = old_attribute_type_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AttributeTypeUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AttributeTypeUpdate):
            return True

        return self.to_dict() != other.to_dict()
