# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class StateBulkUpdate(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attributes': 'dict(str, object)',
        'ids': 'list[int]'
    }

    attribute_map = {
        'attributes': 'attributes',
        'ids': 'ids'
    }

    def __init__(self, attributes=None, ids=None, local_vars_configuration=None):  # noqa: E501
        """StateBulkUpdate - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attributes = None
        self._ids = None
        self.discriminator = None

        if attributes is not None:
            self.attributes = attributes
        if ids is not None:
            self.ids = ids

    @property
    def attributes(self):
        """
        Attribute values to bulk update an entity list.

        :return: The attributes of this StateBulkUpdate. 
        :rtype: dict(str, object)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """
        Attribute values to bulk update an entity list.

        :param attributes: The attributes of this StateBulkUpdate.
        :type: dict(str, object)
        """

        self._attributes = attributes

    @property
    def ids(self):
        """
        Specific IDs to update. This is applied in addition to query parameters.

        :return: The ids of this StateBulkUpdate. 
        :rtype: list[int]
        """
        return self._ids

    @ids.setter
    def ids(self, ids):
        """
        Specific IDs to update. This is applied in addition to query parameters.

        :param ids: The ids of this StateBulkUpdate.
        :type: list[int]
        """

        self._ids = ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StateBulkUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StateBulkUpdate):
            return True

        return self.to_dict() != other.to_dict()
